'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withDeprecationWarning = exports.getTimeStamp = exports.padZeroes = undefined;

var _constants = require('./constants');

var constants = _interopRequireWildcard(_constants);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var padZeroes = exports.padZeroes = function padZeroes(width, n) {
  return ('' + n).padStart(width, '0');
};

var getTimeStamp = exports.getTimeStamp = function getTimeStamp() {
  var now = new Date();
  return '[' + padZeroes(2, now.getHours()) + ':' + padZeroes(2, now.getMinutes()) + ':' + (padZeroes(2, now.getSeconds()) + '.' + padZeroes(3, now.getMilliseconds()) + ']');
};

var shownWarningLabels = [];

var withDeprecationWarning = exports.withDeprecationWarning = function withDeprecationWarning(warningLabel, fn) {
  return function () {
    if (!shownWarningLabels.includes(warningLabel)) {
      var message = void 0;
      switch (warningLabel) {
        case constants.DEPRECATED_THIS_LIFECYCLE_PANEL:
          message = 'this.LifecyclePanel is deprecated, please use this.props.LifecyclePanel instead.';
          break;
        case constants.DEPRECATED_THIS_TRACE:
          message = 'this.trace is deprecated, please use this.props.trace instead.';
          break;
        case constants.DEPRECATED_CLEAR_COUNTERS:
          message = 'clearInstanceIdCounters() is deprecated, please use resetInstanceIdCounters() instead.';
          break;
        default:
          message = 'Unspecified warning.';
      }

      // eslint-disable-next-line no-console
      console.warn('WARNING: react-lifecycle-visualizer: ' + message);
      shownWarningLabels.push(warningLabel);
    }
    return fn.apply(undefined, arguments);
  };
};